#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Aug 19 14:33:51 2020

@author: tanu
"""
#%% load packages
import os
homedir = os.path.expanduser('~')
os.chdir (homedir + '/git/LSHTM_analysis/dynamut')
from submit_dynamut import *
########################################################################
# variables
my_host = 'http://biosig.unimelb.edu.au'
my_prediction_url = f"{my_host}/dynamut/prediction_list"
print(my_prediction_url)

# TODO: add cmd line args
gene = 'gid'
drug = 'streptomycin'
datadir = homedir + '/git/Data/'
indir = datadir + drug + '/input/'
outdir = datadir + drug + '/output/'
outdir_dynamut = outdir + 'dynamut_results/'

my_chain = 'A'
my_email = 'tanushree.tunstall@lshtm.ac.uk'

#my_pdb_file = indir + 'gid_complex.pdb'
my_pdb_file = indir +  gene + '_complex.pdb'
#==============================================================================
# Rerunnig batch 7: 07.txt, # RAN: 12 Aug 15:22, 0 bytes file from previous run!
my_mutation_list = outdir + 'snp_batches/50/snp_batch_07.txt'
my_suffix = 'gid_b7'
#==============================================================================

#==========================
# CALL: submit_dynamut() 
# Data: gid+streptomycin
#==========================
print('\nSubmitting batch for:'
      , '\nFilename : ' , my_mutation_list
      , '\nbatch    : ' , my_suffix
      , '\ndrug     : ' , drug
      , '\ngene     : ' , gene
      , '\npdb file : ' , my_pdb_file)

submit_dynamut(host_url = my_host
                , pdb_file = my_pdb_file
                , mutation_list = my_mutation_list
                , chain = my_chain
                , email_address = my_email
                , prediction_url = my_prediction_url
                , output_dir = outdir_dynamut
                , outfile_suffix = my_suffix) 

#%%#####################################################################               
